#ifndef IN_SCCS_ID
static char *S_inetioctl = " @(#)inetioctl.h (TWG) 2.8.1.5 88/12/08 ";
#endif /* IN_SCCS_ID */
/*
 * @(#) Copyright 1986.  The Wollongong Group, Inc.  All Rights Reserved.
 */
#ifndef IFNAMESIZ
#include "sys/ip.h"
#endif
#ifdef notdef
/*
 * ioctl data to the ip module
 */
struct ipioctl {
	int ipioc_cookie;		/* cookie for mux	*/
	unchar ipioc_name[IFNAMESIZ];	/* Name of Interface	*/
	union {
		struct sockaddr	Ipioc_myaddr;	
		struct sockaddr	Ipioc_dstaddr;
		struct sockaddr	Ipioc_broadaddr;
		ulong	Ipioc_flags;	/* Flags		*/
		struct {
			ulong Iparp_in;  /* Internet Address    */
			short Iparp_flg; /* Flags		*/
			unchar Iparp_en[6]; /* The ethernet address */
		} Ipioc_arp;
		ulong	Ipioc_data[26];	/* Space to hold Ioctls */
	}ipioc_un;
};

#define ipioc_myaddr	ipioc_un.Ipioc_myaddr	     /* address */
#define ipioc_dstaddr	ipioc_un.Ipioc_dstaddr	     /* other end of p-p link */
#define ipioc_broadaddr	ipioc_un.Ipioc_broadaddr     /* broadcast address */
#define ipioc_flags	ipioc_un.Ipioc_flags	     
#define ipioc_arpin	ipioc_un.Ipioc_arp.Iparp_in  
#define ipioc_arpflags	ipioc_un.Ipioc_arp.Iparp_flg 
#define ipioc_arp_enaddr ipioc_un.Ipioc_arp.Iparp_en  
#define ipioc_data	ipioc_un.Ipioc_data
#endif /* notdef */



#define IPIOC			('I'<<8)
#define	IPIOC_SETIFADDR		(IPIOC|1)	/* Set interface Address */
#define IPIOC_GETIFADDR		(IPIOC|2)	/* Get Interface Addr	*/
#define IPIOC_SETIFFLAGS	(IPIOC|3)	/* Set interface flags	*/
#define IPIOC_GETIFFLAGS	(IPIOC|4)	/* Get interface Flags	*/
#define IPIOC_ADDROUTE		(IPIOC|5)	/* Add a route		*/
#define IPIOC_DELETEROUTE	(IPIOC|6)	/* Delete the route	*/
#define IPIOC_SARP		(IPIOC|7)	/* Set Arp table entry	*/
#define IPIOC_DARP		(IPIOC|8)	/* Delete Arp table entry */
#define IPIOC_GARP		(IPIOC|9)	/* Get Arp table entry	*/
#define IPIOC_SET_ARP_PROTO	(IPIOC|10)	/* Set Ethernet protocol*/
#define IPIOC_SETIFDSTADDR	(IPIOC|11)	/* Set Destination Address*/
#define IPIOC_GETIFDSTADDR	(IPIOC|12)	/* Get Destination Address*/
#define IPIOC_SETNAME		(IPIOC|13)	/* Set the interface name */
#define IPIOC_SETIFBRDADDR	(IPIOC|14)	/* Set broadcast addr	*/
#define IPIOC_GETIFBRDADDR	(IPIOC|15)	/* Get broadcast addr	*/
#define IPIOC_SETIFNETMASK	(IPIOC|16)	/* Set the subnetting masks */
#define IPIOC_GETIFNETMASK	(IPIOC|17)	/* Get the subnetting masks */
#define IPIOC_GETIFCONF		(IPIOC|18)	/* Get the interface conf.  */
#define IPIOC_SETIFMETRIC	(IPIOC|19)	/* Set the interface metric */
#define IPIOC_GETIFMETRIC	(IPIOC|20)	/* Get the interface metric */
#define IPIOC_GETIFCOUNTS	(IPIOC|61)	/* Get the interface counts */

#ifdef notdef
#define SIOCADDRT	IPIOC_ADDROUTE
#define SIOCDELRT	IPIOC_DELETEROUTE
#define SIOCSARP	IPIOC_SARP
#define SIOCDARP	IPIOC_DARP
#define SIOCGARP	IPIOC_GARP
#endif /* notdef */

struct	tcpioctl {
	struct {
		ulong	tio_myinaddr;
		ushort	tio_myport;
	} Tio_Port;
};
#define tio_addr	Tio_Port.tio_myinaddr
#define tio_port	Tio_Port.tio_myport
/*
 * The TCP ioctl's that the user can use.
 */
#define TCPIOC			('T'<<8)	/* TCP Ioctl		*/
#define TCPIOC_GETMYPORT	(TCPIOC|1)	/* Find out binding addr*/
#define TCPIOC_DORDWR		(TCPIOC|2)	/* Don't send up M_PROTO */
#define TCPIOC_NORDWR		(TCPIOC|3)	/* Set M_PROTO		*/
#define TCPIOC_SPARE1		(TCPIOC|4)	/* Unused		*/
#define TCPIOC_GETSOCKNAME	(TCPIOC|5)	/* Get Sockname		*/
#define TCPIOC_GETPEERNAME	(TCPIOC|6)	/* Get Peer Name	*/
#define TCPIOC_SPARE2		(TCPIOC|7)	/* Unused		*/
#define TCPIOC_SETQLENGTH	(TCPIOC|8)	/* Set Queue Length 	*/
#define TCPIOC_GETMYSTATE       (TCPIOC|9)      /* Get the TCP STate    */
#define TCPIOC_DATAPEND         (TCPIOC|10)     /* Check the queue len  */
#define TCPIOC_NEWPORT          (TCPIOC|11)     /* Give me a new port   */
#define TCPIOC_SOCKOPT          (TCPIOC|12)     /* Handle socket options */
#define TCPIOC_GETFAMILY	(TCPIOC|13) /* AFUN - Get address family */
#define TCPIOC_SETFAMILY	(TCPIOC|14) /* AFUN - Set address family */
#define TCPIOC_GETPORT		(TCPIOC|15) /* AFUN - Get Port for afu file */

/*
 * The UDP ioctl's that the user can use.
 */
#define UDPIOC			('U'<<8)	   /* UDP Ioctl		      */
#define UDPIOC_GETMYSTATE       TCPIOC_GETMYSTATE  /* Get the UDP's TLI state */
#define UDPIOC_GETSOCKNAME      TCPIOC_GETSOCKNAME /* Get the UDP's Sockname  */
#define UDPIOC_GETPEERNAME      TCPIOC_GETPEERNAME /* Get the UDP's Peer name */
#define UDPIOC_SOCKOPT          TCPIOC_SOCKOPT     /* Handle socket options   */
#define UDPIOC_CONNECT		UDPIOC|1	   /* Connect to peer's addr  */
#define UDPIOC_DO_CKSUM_IN	UDPIOC|2	   /* Checksum on input       */
#define UDPIOC_DO_CKSUM_OUT	UDPIOC|3	   /* Checksum on output      */
#define UDPIOC_DONT_CKSUM_IN	UDPIOC|4	   /* Don't checksum on input */
#define UDPIOC_DONT_CKSUM_OUT	UDPIOC|5	   /* Don't checksum on output*/
#define UDPIOC_GETFAMILY	(TCPIOC|13) /* AFUN Get address family	*/
#define UDPIOC_SETFAMILY	(TCPIOC|14) /* AFUN Set address family	*/
#define UDPIOC_GETPORT		(TCPIOC|15) /* AFUN Get Port for afu file */
#define	UDPIOC_GETFILE		UDPIOC|6    /* AFUN Get filename knowing port */

/* The CIRC ioctls - AFUN */
#define CIRCIOC			('C'<<8)	/* AFUN - CIRC Ioctl */
#define CIRCIOC_GETFAMILY	(TCPIOC|13)     /* AFUN - Get address family */
#define CIRCIOC_SETFAMILY	(TCPIOC|14)     /* AFUN - Set address family */
#define CIRCIOC_LINK		(CIRCIOC|1)	/* AFUN - cross link streams */

/*
 * The RAW ioctl's that the user can use.
 */
#define RAWIOC			('R'<<8)	   /* RAW Ioctl		*/
#define RAWIOC_GETMYSTATE       TCPIOC_GETMYSTATE  /* Get the RAW's TLI state */
#define RAWIOC_GETSOCKNAME      TCPIOC_GETSOCKNAME /* Get the RAW's Sockname  */
#define RAWIOC_GETPEERNAME      TCPIOC_GETPEERNAME /* Get the RAW's Peer name */
#define RAWIOC_SOCKOPT          TCPIOC_SOCKOPT     /* Handle socket options   */
#define RAWIOC_PROTO     	RAWIOC|1      /* Set RAW's proto # and family */
#define RAWIOC_CONNECT     	RAWIOC|2      /* Connect to peer's address    */
#define RAWIOC_GETFAMILY	TCPIOC_GETFAMILY /* AFUN - Get address family */
#define RAWIOC_SETFAMILY	TCPIOC_SETFAMILY /* AFUN - Set address family */

/*
 * 4.2 ioctls
 */
#define	IOCPARM_MASK	0x7f		/* parameters must be < 128 bytes */
#define	IOC_VOID	0x20000000	/* no parameters */
#define	IOC_OUT		0x40000000	/* copy out parameters */
#define	IOC_IN		0x80000000	/* copy in parameters */
#define	IOC_INOUT	(IOC_IN|IOC_OUT)
/* the 0x20000000 is so we can distinguish new ioctl's from old */
#define	_IO(x,y)	(IOC_VOID|(x<<8)|y)
#define	_IOR(x,y,t)	(IOC_OUT|((sizeof(t)&IOCPARM_MASK)<<16)|(x<<8)|y)
#define	_IOW(x,y,t)	(IOC_IN|((sizeof(t)&IOCPARM_MASK)<<16)|(x<<8)|y)
/* this should be _IORW, but stdio got there first */
#define	_IOWR(x,y,t)	(IOC_INOUT|((sizeof(t)&IOCPARM_MASK)<<16)|(x<<8)|y)

#define	TIOCREMOTE	_IO('t', 105)		/* remote input editing */
#define	TIOCPKT		_IOW('t', 112, int)	/* pty: set/clear packet mode */
#define		TIOCPKT_DATA		0x00	/* data packet */
#define		TIOCPKT_FLUSHREAD	0x01	/* flush packet */
#define		TIOCPKT_FLUSHWRITE	0x02	/* flush packet */
#define		TIOCPKT_STOP		0x04	/* stop output */
#define		TIOCPKT_START		0x08	/* start output */
#define		TIOCPKT_NOSTOP		0x10	/* no more ^S, ^Q */
#define		TIOCPKT_DOSTOP		0x20	/* now do ^S ^Q */

#define	FIONREAD	_IOR('f', 127, int)	/* get # bytes to read */
#define	FIONBIO		_IOW('f', 126, int)	/* set/clear non-blocking i/o */
#define	FIOASYNC	_IOW('f', 125, int)	/* set/clear async i/o */
#define	FIOSETOWN	_IOW('f', 124, int)	/* set owner */
#define	FIOGETOWN	_IOR('f', 123, int)	/* get owner */

#ifndef FIONCLEX
#define	FIONCLEX	_IO('f', 1)		/* Dont close on exec */
#define	FIOCLEX		_IO('f', 2)		/* close on exec */
#endif /* FIONCLEX */

/*
 * translate BSD ioctl commands to twg ioctl commands.
 */
#define SIOCGIFCONF	IPIOC_GETIFCONF
#define SIOCGIFFLAGS	IPIOC_GETIFFLAGS
#define SIOCGIFADDR	IPIOC_GETIFADDR
#define SIOCGIFDSTADDR	IPIOC_GETIFDSTADDR
#define SIOCGIFBRDADDR	IPIOC_GETIFBRDADDR
#define SIOCGIFMETRIC	IPIOC_GETIFMETRIC
#define SIOCGIFNETMASK	IPIOC_GETIFNETMASK
#define SIOCADDRT	IPIOC_ADDROUTE
#define SIOCDELRT	IPIOC_DELETEROUTE

#ifdef notdef
/* socket i/o controls */
#define	SIOCSHIWAT	_IOW('s',  0, int)		/* set high watermark */
#define	SIOCGHIWAT	_IOR('s',  1, int)		/* get high watermark */
#define	SIOCSLOWAT	_IOW('s',  2, int)		/* set low watermark */
#define	SIOCGLOWAT	_IOR('s',  3, int)		/* get low watermark */
#define	SIOCATMARK	_IOR('s',  7, int)		/* at oob mark? */
#define	SIOCSPGRP	_IOW('s',  8, int)		/* set process group */
#define	SIOCGPGRP	_IOR('s',  9, int)		/* get process group */

#define	SIOCADDRT	_IOW('r', 10, struct route)	/* ADD route */
#define	SIOCDELRT	_IOW('r', 11, struct route)	/* delete route */

#define	SIOCSIFADDR	_IOW('i', 12, struct ifreq)	/* set ifnet address */
#define	SIOCGIFADDR	_IOWR('i',13, struct ifreq)	/* get ifnet address */
#define	SIOCSIFDSTADDR	_IOW('i', 14, struct ifreq)	/* set p-p address */
#define	SIOCGIFDSTADDR	_IOWR('i',15, struct ifreq)	/* get p-p address */
#define	SIOCSIFFLAGS	_IOW('i', 16, struct ifreq)	/* set ifnet flags */
#define	SIOCGIFFLAGS	_IOWR('i',17, struct ifreq)	/* get ifnet flags */
#define	SIOCGIFBRDADDR	_IOWR('i',18, struct ifreq)	/* get broadcast addr */
#define	SIOCGIFCONF	_IOWR('i',20, struct ifconf)	/* get ifnet list */
#define	SIOCSIFENADDR	_IOW('i', 21, struct ifreq)	/* set ethernet addr */
#define	SIOCGIFENADDR	_IOWR('i',22, struct ifreq)	/* get ethernet addr */
#define SIOCSEPIF	_IOW('i', 23, struct epcontroller)/* set raw ether */
#define SIOCGEPIF	_IOWR('i',24, struct epcontroller)/* get raw ether */

#define	SIOCSARP	_IOW('i', 30, struct arpreq)	/* set arp entry */
#define	SIOCGARP	_IOWR('i',31, struct arpreq)	/* get arp entry */
#define	SIOCDARP	_IOW('i', 32, struct arpreq)	/* delete arp entry */
#endif /* notdef */

#ifdef KERNEL
struct ipb *ip_getif();
#endif /* KERNEL */

