#ifndef IN_SCCS_ID
static char *S_ip = " @(#)ip.h (TWG) 2.8 88/06/22 ";
#endif /* IN_SCCS_ID */
/*
 * @(#) Copyright 1986.  The Wollongong Group, Inc.  All Rights Reserved.
 */

#ifdef XENIX

/* DL_IPX25 required for ACC changes - this should really be in
 * /usr/include/sys/lihdr.h but isn't as yet.
 */
#define DL_IPX25	5
#endif /* XENIX */
/*
 * Definitions for internet protocol version 4.
 * Per RFC 791, September 1981.
 */
#define	IPVERSION	4

#ifdef XENIX
/* #pragma pack(1) */
#endif

/*
 * Structure of an internet header, naked of options.
 *
 * We declare ip_len and ip_off to be short, rather than ushort
 * pragmatically since otherwise unsigned comparisons can result
 * against negative integers quite easily, and fail in subtle ways.
 */
struct ip {
#if (__vax__ || __ns32000__ || __i386__)
	unchar	ip_hl:4,		/* header length */
		ip_v:4;			/* version */
#else
	unchar	ip_v:4,			/* Version of IP (4)  */
		ip_hl:4;		/* Header length << 2 */
#endif /* __vax__ */
	unchar	ip_tos;			/* type of service */
	short	ip_len;			/* total length */
	ushort	ip_id;			/* identification */
	short	ip_off;			/* fragment offset field */
#define	IP_DF 0x4000			/* dont fragment flag */
#define	IP_MF 0x2000			/* more fragments flag */
	unchar	ip_ttl;			/* time to live */
	unchar	ip_p;			/* protocol */
	ushort	ip_sum;			/* checksum */
	ulong	ip_src;			/* source address */
	ulong	ip_dst;		 	/* destination address */
};


#ifdef XENIX
/* #pragma pack() */
#endif

#define	IPHLEN	sizeof(struct ip)

/*
 * Definitions for options.
 */
#define	IPOPT_COPIED(o)		((o)&0x80)
#define	IPOPT_CLASS(o)		((o)&0x40)
#define	IPOPT_NUMBER(o)		((o)&0x3f)

#define	IPOPT_CONTROL		0x00
#define	IPOPT_RESERVED1		0x10
#define	IPOPT_DEBMEAS		0x20
#define	IPOPT_RESERVED2		0x30

#define	IPOPT_EOL		0		/* end of option list */
#define	IPOPT_NOP		1		/* no operation */

#define	IPOPT_RR		7		/* record packet route */
#define	IPOPT_TS		68		/* timestamp */
#define	IPOPT_SECURITY		130		/* provide s,c,h,tcc */
#define	IPOPT_LSRR		131		/* loose source route */
#define IPOPT_EXTSECURITY	133		/* DOD extended security */
#define	IPOPT_SATID		136		/* satnet id */
#define	IPOPT_SSRR		137		/* strict source route */

/*
 * Offsets to fields in options other then EOL and NOP.
 */
#define IPOPT_OPTVAL		0		/* option ID */
#define IPOPT_OLEN		1		/* option length */
#define IPOPT_OFFSET		2		/* offset within option */
#define IPOPT_MINOFF		4		/* min value of above */

/*
 * Time stamp option structure.
 */
struct	ip_timestamp {
	unchar	ipt_code;		/* IPOPT_TS */
	unchar	ipt_len;		/* size of structure (variable) */
	unchar	ipt_ptr;		/* index of current entry */
#if defined(R_TO_L_BITS) || defined(__vax__) || defined(__ns32000__) || defined(__i386__)
	unchar	ipt_flg:4,		/* flags, see below */
		ipt_oflw:4;		/* overflow counter */
#else
	unchar	ipt_flag;		/* flags, see below */
#endif /* R_TO_L_BITS || __vax__ */
	union {
		ulong	ipt_time[1];
		struct	Ipt_ta {
#ifndef XENIX
			ulong ipt_addr;
#else
			inaddr_t ipt_addr;
#endif /* XENIX */
			ulong Ipt_time;
		} ipt_ta[1];
	} un_ipts;
};

#define IPT_FLG(ipt)	((ipt)->ipt_flag & 0x0f)
#define IPT_OVFLW(ipt)	(((ipt)->ipt_flag >>4) & 0x0f)

/* flag bits for ipt_flg */
#define	IPOPT_TS_TSONLY		0		/* timestamps only */
#define	IPOPT_TS_TSANDADDR	1		/* timestamps and addresses */
#define	IPOPT_TS_PRESPEC	3		/* specified modules only */

/* bits for security (not byte swapped) */
#ifdef notdef
#define	IPOPT_SECUR_UNCLASS	0x0000
#define	IPOPT_SECUR_CONFID	0xf135
#define	IPOPT_SECUR_EFTO	0x789a
#define	IPOPT_SECUR_MMMM	0xbc4d
#define	IPOPT_SECUR_RESTR	0xaf13
#define	IPOPT_SECUR_SECRET	0xd788
#define	IPOPT_SECUR_TOPSECRET	0x6bc5

#endif /* notdef */
/*
 * U.S. classification levels supported by the new variable length IP Security
 * Option.  Dated 18 MAR 1985.
 */
#define	IPOPT_SECUR_TOPSECRET	0xde
#define	IPOPT_SECUR_SECRET	0xad
#define	IPOPT_SECUR_CONFID	0x7a
#define	IPOPT_SECUR_UNCLASS	0x55
#define IPOPT_SECUR_LENGTH	4

/*
 * The current list of Accrediting Authorities allowed.
 */
#define IPOPT_SECUR_MASK	0xf0
#define IPOPT_SECUR_DCA		0x80	/* Defense Communications Agency */
#define IPOPT_SECUR_JCS		0x40	/* Joint Chiefs of Staff */
#define IPOPT_SECUR_DIA		0x20	/* Defense Intelligence Agency */
#define IPOPT_SECUR_NSA		0x10	/* National Security Agency */
#define IPOPT_SECUR_MORE	0x1	/* More Accrediting Authorities in next byte */

/*
 * Structure for the variable length IP Security Option.
 * As of 18 MAR 1985, there is only one byte for the authority field.
 * If this changes, change -- IPOPT_SECUR_LENGTH define.
 */
struct ipoption_security {
	unchar	ipsec_type;		/* 130 */
	unchar	ipsec_length;		/* IPOPT_SECUR_LENGTH */
	unchar	ipsec_class;		/* IPOPT_SECUR_TOPSECRET ... */
	unchar	ipsec_authority[1];	/* IPOPT_SECUR_DCA ... */
};

/* structure for Stream identifier */
struct	ip_satid{
	unchar	ipsat_code;		/* IPOPT_SATID		 */
	unchar	ipsat_len;		/* size of structure (4) */
	ushort	ipsat_type;		/* stream identifier	 */
};

/*
 * Internet implementation parameters.
 */
#define	MAXTTL		255		/* maximum time to live (seconds) */
#define	IPFRAGTTL	15		/* time to live for frag chains */
#define	IPTTLDEC	 1		/* subtracted when forwarding */

extern int iperrcode;
#define	ILOG(x)	{iperrcode = x;}
/*
 * ip error code in ip_input.c
 */
#define	IPE_SMALL	1	/* smaller than ip header */
#define	IPE_ALIGN	2	/* rptr not at word boundary */
#define	IPE_OPTION	3	/* pullup option failed */
#define	IPE_CKSUM	4	/* bad checksum */
#define	IPE_BADLEN	5	/* bad ip_len */
#define	IPE_SHORT	6	/* mesg too short */
#define	IPE_LONG	6	/* mesg too long */
#define	IPE_ALLOCB	11	/* allocb failed */
#define	IPE_DROPME	21	/* incoming is totally overlapped */
#define	IPE_RSADJ1	22	/* adjmsg failed */
#define	IPE_RSADJ2	23	/* adjmsg failed */
#define	IPE_TTL		26	/* time to live expires */

/*
 * ip reassembly header: global pointer is 'iprsq'
 * ipq's next by b_next and prev by b_prev
 */
struct ipq {
	struct	ipq *ipq_next;		/* to other header */
	struct	ipq *ipq_prev;		/* circular link */
	unchar	ipq_ttl;		/* time for reass q to live */
	unchar	ipq_p;			/* protocol of this fragment */
	ushort	ipq_id;			/* sequence id for reassembly */
	struct	ipfrag *ipq_fnext;	/* to 1st fragment */
	struct	ipfrag *ipq_fprev;	/* circular link */
	ulong	ipq_src;		/* ip src address */
	ulong	ipq_dst;	 	/* ip dst address */
	mblk_t	*ipq_dtom;		/* back pointer to mblk_t */
};

/*
 * ip header, when holding a fragment.
 * ipf_fnext must be the same offset of ipq_fnext (for ip_enq()/ip_deq())
 * use ip_src/ip_dst field to point to next and prev fragments
 * use old ip_ttl/ip_p/ip_sum as a pointer to mblk_t
 */
struct	ipfrag {
#if (__vax__ || __ns32000__ || __i386__)
	unchar	ipf_hl:4,
		ipf_v:4;
#else
	unchar	ipf_v:4,
		ipf_hl:4;
#endif /* __vax__ */
	unchar	ipf_mff;		/* copied from (ip_off&IP_MF) */
	short	ipf_len;
	ushort	ipf_id;
	short	ipf_off;
	mblk_t	*ipf_dtom;		/* back pointer */
	struct	ipfrag *ipf_fnext;	/* next fragment */
	struct	ipfrag *ipf_fprev;	/* previous fragment */
};

/*
 * flags passed to ip_output as last parameter
 */
#define	IP_FORWARDING		0x1	/* most of ip header exists */
#define	IP_ROUTETOIF		0x10	/* same as SO_DONTROUTE */
#define IP_ALLOWBROADCAST	0x20	/* same as SO_BROADCAST */

/*
 * ip upper queues private data structure
 */
struct ipd {
	queue_t	*id_rdq;	/* read queue */
	short	id_topid;	/* who is on top */
	char	id_mstate;	/* mux state to top */
	unchar	id_prot;	/* tcp/udp/... protocol # */
	short	id_flags;
};

/*
 * ip bottom queues (for mux) private data structure
 */
struct ipb {
	queue_t	*ib_wrq;	/* write queue				*/
	struct	ipb *ib_next;	/* Next one in line			*/
	short	ib_sap;		/* ethernet type or source sap #	*/
	ushort	ib_flag;	/* see if.h 				*/
	unchar	ib_mstate;	/* mux state to bottom 			*/
	unchar	ib_bottype;	/* down below subnet type: see lihdr.h	*/
#define if_unit ib_unit
	unchar	ib_unit;	/* Unit number				*/
	int 	ib_metric;	/* routing metric (external only)	*/
	struct 	ifaddr *if_addrlist;
#ifdef XENIX
#define if_addr ib_myinaddr
	long	ib_myinaddr;	/* internet address of local host	*/
	long	ib_hisinaddr;	/* host (if point-to-point) or net #	*/
#define ib_net	ib_hisinaddr
#define ib_broadcastaddr ib_hisinaddr
#endif /* XENIX */
	ushort	ib_maxpsz;	/* max packet size going down		*/
#define ib_mtu	ib_maxpsz
	ushort	ib_minpsz;	/* min packet size going down		*/
	queue_t	*ib_qtop;	/* control chan write q			*/
	int	ib_cookie;	/* cookie from I_LINK/UNLINK		*/
	int	ib_ipackets;	/* Input Packets Count.			*/
	int	ib_opackets;	/* Ouput Packets Count.			*/
	ushort	ib_ierrors;	/* Input Errors				*/
	ushort	ib_oerrors;	/* Output Errors			*/
#define IFNAMESIZ	16
#define if_name ib_name
	unchar	ib_name[IFNAMESIZ];/* Fourteen char name max		*/
};

#ifdef XENIX
/*
 * flags
 */
#define IFF_UP		(1<<0)	/* interface is up			*/
#define IFF_POINTTOPOINT	(1<<1)	/* point-to-point to 'that' 	*/
#define IFF_ARP		(1<<2)	/* perform ARP				*/
#define	IFF_BROADCAST	(1<<3)	/* interface allows broadcasting	*/
#define IFF_LOCAL	(1<<4)	/* For Subnets				*/
#define IFF_ROUTE	(1<<5)	/* Routing 				*/
#define IFF_BINDNEED	(1<<6)	/* during binding			*/
#define IFF_IPTOX25 	(1<<10) /* for ACP IPX25 interface		*/
#endif /* XENIX */

#define ip_bottom	ipb	/* Only temporary until code is cleaned */

extern struct ipb ipb[];
extern struct ipd ipd[];
extern ipd_cnt, ipb_cnt;
#ifdef XENIX
extern struct ipb *ip_ifwithaddr(), *ip_ifonnetof(); 
#endif /* XENIX */
extern struct ipb *ipbnext;


#define	IPCHAN(idp)	((int)idp - (int)ipd) / sizeof(struct ipd)
#define	IPBCHAN(ibp)	((int)ibp - (int)ipb) / sizeof(struct ipb)
#define IPCTLCHAN	0		/* ip control channel */

/*
 * Commands from TCP/UDP/RAW in M_CTL
 */
#define IPIF_UNLINKED	0		/* Module is unlinked    	*/
#define IPIF_LINKED	1		/* Module is linked    		*/
#define IPIF_LINKING	2		/* Modules are linking		*/
#define IPIF_UNLINKING	3		/* Module is unlinking 		*/
#define IPIF_GETMYADDR	4		/* Get the internet addr	*/
/*#define IPIF_DATANXT	5		/* Data Follows			*/
#define IPIF_CLOSED	6		/* The Above Layer is closed	*/
#define IPIF_CTLERROR	7		/* This is a control Error 	*/
#define IPIF_GETHISADDR	8		/* Get his internet addr	*/
#define IPIF_OPTIONS	9		/* Set or get options		*/
/*
 * The interface to IP from TCP/UDP/RAW.
 */
union iptun {
#ifdef IPIF_DATANXT
	/*
	 * IPIF_DATANXT.
	 */
	struct ipindata {
		ulong ipin_src;			/* Source addr.		*/
		ulong ipin_dst;			/* Dest. addr		*/
		struct	ipb *ipin_rt;		/* XXX passed		*/
	} ipindata;
#endif /* IPIF_DATANXT */
	/*
	 * Linking Stuff
	 */
	long	ipln_id;			/* Module Id.		*/
	/*
	 * IPIF_GETMYADDR
	 */
	struct ipun_addr {
		ulong ipad_addr;		/* Address		*/
		long	ipad_mtu;		/* MTU size of the IF	*/
	} ipun_addr;
	long	ipun_error;			/* Error codes from icmp*/
};
typedef short ipfcmd;
struct ip_if {
	ipfcmd ipf_type;	/* The command	*/
	union iptun ipf_un;	/* All the rest.*/
};
#ifdef IPIF_DATANXT
#define ipf_src	ipf_un.ipindata.ipin_src
#define ipf_dst ipf_un.ipindata.ipin_dst
#define ipf_rt	ipf_un.ipindata.ipin_rt
#endif /* IPIF_DATANXT	*/
#define ipf_id  ipf_un.ipln_id
#define ipf_addr ipf_un.ipun_addr.ipad_addr
#define ipf_mtu ipf_un.ipun_addr.ipad_mtu
#define ipf_srt	ipf_un.ipun_addr.ipad_rt
#define ipf_errorcode	ipf_un.ipun_error

/*
 * Overlay for ip header used by other protocols (tcp, udp).
 */
struct ipovly {
	caddr_t	ih_next, ih_prev;	/* for protocol sequence q's */
	unchar	ih_x1;			/* (unused) */
	unchar	ih_pr;			/* protocol */
	short	ih_len;			/* protocol length */
	ulong   ih_src;			/* source internet address */
	ulong   ih_dst;			/* destination internet address */
};

struct	ipstat {
	int	ips_badsum;		/* checksum bad */
	int	ips_tooshort;		/* packet too short */
#ifdef SHORT_IDENT
	int	Ips_toosmall;		/* not enough data */
#define ips_toosmall Ips_toosmall	/* Compiler problems CPP modified */
#else
	int	ips_toosmall;		/* not enough data */
#endif /* SHORT_IDENT */
	int	ips_badhlen;		/* ip header length < data size */
	int	ips_badlen;		/* ip length < ip header length */
	int	ips_forward;		/* packets forwarded */
	int	ips_cantforward;	/* packets rcvd for unreachable dest */
	int	ips_redirectsent;	/* packets forwarded on same net */
};

/*
 * External Interface to IP Managers 
 */
struct	ipmgr {
	long	ipm_code;
#define		IPM_INCALL	661	/* Incoming Call (I_SENDFD preceeds) */
#define		IPM_HANGUP	662	/* Take Interface Down */
#define		IPM_CMDTYPE	663	/* Not implemented - for future use */
	long	ipm_inaddr;
	long	ipm_error;
	long	ipm_subcmd;		/* Not implemented - for future use */
	char	ipm_ifname[IFNAMESIZ];
#define		IPMGRPSIZ	48
	char	ipm_fromgroup[IPMGRPSIZ];
	char	ipm_iodata[IPMGRPSIZ];	/* Space for I/O data */
	long	ipm_timeout;
};

/*
 * Structure stored in tcpcb.t_ipopt and passed to 
 * ip_output in a message when ip options are in use.
 * The actual lenght of the options (including ipopt_dst)
 * is in the msg->b_wptr.
 */

#define MAX_IPOPTLEN	40

struct ipoption {
	ulong	ipopt_dst;	/* first-hop dst if source routed */
	char	ipopt_list[MAX_IPOPTLEN];
}; 

/*
 * IP/ICMP Error Messages.
 */
#define	PRC_IFDOWN		0	/* interface transition */
#define	PRC_ROUTEDEAD		1	/* select new route if possible */
#define	PRC_QUENCH		4	/* some said to slow down */
#define	PRC_MSGSIZE		5	/* message size forced drop */
#define	PRC_HOSTDEAD		6	/* normally from IMP */
#define	PRC_HOSTUNREACH		7	/* ditto */
#define	PRC_UNREACH_NET		8	/* no route to network */
#define	PRC_UNREACH_HOST	9	/* no route to host */
#define	PRC_UNREACH_PROTOCOL	10	/* dst says bad protocol */
#define	PRC_UNREACH_PORT	11	/* bad port # */
#define	PRC_UNREACH_NEEDFRAG	12	/* IP_DF caused drop */
#define	PRC_UNREACH_SRCFAIL	13	/* source route failed */
#define	PRC_REDIRECT_NET	14	/* net routing redirect */
#define	PRC_REDIRECT_HOST	15	/* host routing redirect */
#define	PRC_REDIRECT_TOSNET	16	/* redirect for type of service & net */
#define	PRC_REDIRECT_TOSHOST	17	/* redirect for tos & host */
#define	PRC_TIMXCEED_INTRANS	18	/* packet lifetime expired in transit */
#define	PRC_TIMXCEED_REASS	19	/* lifetime expired on reass q */
#define	PRC_PARAMPROB		20	/* header incorrect */

#define	PRC_NCMDS		21

#ifdef PRCREQUESTS
char	*prcrequests[] = {
	"IFDOWN", "ROUTEDEAD", "#2", "#3",
	"QUENCH", "MSGSIZE", "HOSTDEAD", "HOSTUNREACH",
	"NET-UNREACH", "HOST-UNREACH", "PROTO-UNREACH", "PORT-UNREACH",
	"FRAG-UNREACH", "SRCFAIL-UNREACH", "NET-REDIRECT", "HOST-REDIRECT",
	"TOSNET-REDIRECT", "TOSHOST-REDIRECT", "TX-INTRANS", "TX-REASS",
	"PARAMPROB"
};
#endif

#ifdef KERNEL
#ifdef XENIX
struct ipb *if_ifwithaddr();
struct ipb *if_ifwithnet();
unsigned long if_makeaddr();
#endif /*XENIX */
struct ipb *if_ifonnetof();
struct ipb *ip_findemd();
mblk_t *ip_alignmsg();
#endif /* KERNEL */


/*
 * The following defines and IP_args structure are for
 * sending "arguments" down to IP from the upper level protocol.
 * The argument list should be ended with IPENDLIST as the argument type.
 * The block after the arguments block will contain data.
 */
#define IPENDLIST	0
#define IPFLAGS		1
#define IPOPTS		3
struct IP_args {
	ushort IP_type;		/* argument type */
	ushort IP_length;	/* argument length */
};
